/**
 * CMI : Cluster Method Invocation
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: carol@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * --------------------------------------------------------------------------
 * $Id: CoordinatedServerClusterViewManager.java 1882 2008-06-29 17:05:02Z loris $
 * --------------------------------------------------------------------------
 */

package org.ow2.cmi.controller.server.impl.coordinator;

import java.util.List;
import java.util.Set;
import java.util.UUID;

import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicSession;

import net.jcip.annotations.ThreadSafe;

import org.ow2.cmi.controller.server.AbsServerClusterViewManager;
import org.ow2.cmi.controller.server.DistributedObjectInfo;
import org.ow2.cmi.controller.server.filter.IFilter;
import org.ow2.cmi.reference.CMIReference;
import org.ow2.cmi.reference.ObjectNotFoundException;
import org.ow2.cmi.reference.ServerNotFoundException;
import org.ow2.cmi.reference.ServerRef;

/**
 * @author Loris Bouzonnet
 */
@ThreadSafe
public abstract class CoordinatedServerClusterViewManager extends
        AbsServerClusterViewManager {


    private Topic topic;

    private TopicConnection topicConnection;

    private TopicSession session;

    protected TopicConnection getTopicConnection() {
        return topicConnection;
    }

    protected void setTopicConnection(final TopicConnection topicConnection) {
        this.topicConnection = topicConnection;
    }

    protected Topic getTopic() {
        return topic;
    }

    protected void setTopic(final Topic topic) {
        this.topic = topic;
    }

    protected TopicSession getSession() {
        return session;
    }

    protected void setSession(final TopicSession session) {
        this.session = session;
    }


    @Override
    protected void addDistributedObjectInfo(final String objectName,
            final DistributedObjectInfo distributedObjectInfo) {
        // TODO Auto-generated method stub

    }

    @Override
    public void broadCastArchive(final Object archiveId, final byte[] bytesOfFile) {
        // TODO Auto-generated method stub

    }

    @Override
    protected boolean containObject(final String objectName) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public void doStart() {
        // TODO Auto-generated method stub

    }

    @Override
    public void doStop() {
        // TODO Auto-generated method stub

    }

    @Override
    protected DistributedObjectInfo getDistributedObjectInfo(final String objectName)
            throws ObjectNotFoundException {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    protected void initStats() {
        // TODO Auto-generated method stub

    }

    @Override
    public boolean isAlreadyDistributed(final Object archiveId) {
        // TODO Auto-generated method stub
        return false;
    }

    @Override
    public void removeDistributedArchive(final Object archiveId) {
        // TODO Auto-generated method stub

    }

    @Override
    protected void setDistributedObjectInfo(final String objectName,
            final DistributedObjectInfo distributedObjectInfo) {
        // TODO Auto-generated method stub

    }

    public void addCMIReference(final CMIReference cmiReference) {
        // TODO Auto-generated method stub

    }

    public void addGlobalFilter(final IFilter filter) throws IllegalArgumentException {
        // TODO Auto-generated method stub

    }

    public void addPoolToEmpty(final String objectName) {
        // TODO Auto-generated method stub

    }

    public void addServerToBlackList(final ServerRef serverRef) {
        // TODO Auto-generated method stub

    }

    public List<CMIReference> getCMIReferences(final String objectName)
            throws ObjectNotFoundException {
        // TODO Auto-generated method stub
        return null;
    }

    public List<CMIReference> getCMIReferences(final String objectName,
            final String protocolName, final Set<Object> qualities)
            throws ObjectNotFoundException {
        // TODO Auto-generated method stub
        return null;
    }

    public Set<String> getClusterNames() {
        // TODO Auto-generated method stub
        return null;
    }

    public List<IFilter> getGlobalFilters() {
        // TODO Auto-generated method stub
        return null;
    }

    public int getNbClientsConnectedToProvider() {
        // TODO Auto-generated method stub
        return 0;
    }

    public Set<String> getObjectNames() {
        // TODO Auto-generated method stub
        return null;
    }

    public Set<String> getObjectNames(final String clusterName) {
        // TODO Auto-generated method stub
        return null;
    }

    public boolean isServerBlackListed(final ServerRef serverRef) {
        // TODO Auto-generated method stub
        return false;
    }

    public void registerClient(final UUID uuid) {
        // TODO Auto-generated method stub

    }

    public void removeCMIReference(final CMIReference cmiReference) {
        // TODO Auto-generated method stub

    }

    public void removeGlobalFilter(final IFilter filter) {
        // TODO Auto-generated method stub

    }

    public void removePoolToEmpty(final String objectName) {
        // TODO Auto-generated method stub

    }

    public void removeServerFromBlackList(final ServerRef serverRef) {
        // TODO Auto-generated method stub

    }

    public void setDelayToRefresh(final int delay) {
        // TODO Auto-generated method stub

    }

    public void setLoadFactor(final ServerRef serverRef, final int loadFactor) {
        // TODO Auto-generated method stub

    }

    public long getDateOfConfiguration() {
        // TODO Auto-generated method stub
        return 0;
    }

    public int getDelayToRefresh() {
        // TODO Auto-generated method stub
        return 0;
    }

    public int getLoadFactor(final ServerRef serverRef)
            throws ServerNotFoundException {
        // TODO Auto-generated method stub
        return 0;
    }

    public boolean isPoolToEmpty(final String objectName)
            throws ObjectNotFoundException {
        // TODO Auto-generated method stub
        return false;
    }

}
